nus_tdt_project/config/routes.rb
Rails.application.routes.draw do

  get 'notifications/index'
  root "feeds#index"

  # Devise
  devise_for :users, controllers: {
    registrations: "users/registrations",
    omniauth_callbacks: "users/omniauth_callbacks"
  }

  # User - Albums/Photos
  resources :users, except: [:new, :create] do
    resources :photos, except: [:index]
    resources :albums, except: [:index]
  end

  resources :photos, only: [:index] do
    resources :comments, module: :photos
    put :like, on: :member
  end

  resources :albums, only: [:index] do
    resources :comments, module: :albums
    put :like, on: :member
  end

  resources :feeds, only: [:index]

  resources :discovers, only: [:index] do
    member do
      post :follow_user
      post :unfollow_user
    end
  end

  resources :conversations, only: [:create] do
    resources :messages, only: [:create]
    member do
      post :close
    end
  end

  mount ActionCable.server => '/cable'

end

nus_tdt_project/app/models/comment.rb
class Comment < ApplicationRecord
   # Associations
  belongs_to :commentable, :polymorphic => true
  belongs_to :user

  # Validations
  validates :commentable, :user, presence: true

  after_create_commit { notify }

  private
    def notify
      Notification.create(event: "<a data-remote='true' href='/users/#{commentable.user_id}/#{self.commentable_type.downcase}s/#{commentable.id}'>#{I18n.t('notifications.comments', user: self.user.nick_name, commentable: self.commentable_type)}</a>")
    end
end

nus_tdt_project/app/controllers/albums/comments_controller.rb
class Albums::CommentsController < CommentsController
  before_action :set_commentable

  private

    def set_commentable
      @commentable = Album.find(params[:album_id])
    end
end

nus_tdt_project/app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  before_action :set_comment, only: [:show, :edit, :update, :destroy]

  # GET /comments
  # GET /comments.json
  def index
    @comments = Comment.all
  end

  # GET /comments/1
  # GET /comments/1.json
  def show
  end

  # GET /comments/1/edit
  def edit
  end

  # POST /comments
  # POST /comments.json
  def create
    @comment = @commentable.comments.new(comment_params)
    @comment.user_id = current_user.id
    @comment.save
    # broadcasting comments using pusher
    Pusher.trigger('comment-channel','new-comment', {
      comment: @comment.body
    })
  end

  # PATCH/PUT /comments/1
  # PATCH/PUT /comments/1.json
  def update
    respond_to do |format|
      if @comment.update(comment_params)
        format.html { redirect_to @comment, notice: 'Comment was successfully updated.' }
        format.json { render :show, status: :ok, location: @comment }
      else
        format.html { render :edit }
        format.json { render json: @comment.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /comments/1
  # DELETE /comments/1.json
  def destroy
    @comment.destroy
    respond_to do |format|
      format.html { redirect_to comments_url, notice: 'Comment was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_comment
      @comment = Comment.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def comment_params
      params.fetch(:comment, {}).permit(:body)
    end
end

nus_tdt_project/app/controllers/photos/comments_controller.rb
class Photos::CommentsController < CommentsController
  before_action :set_commentable

  private

    def set_commentable
      @commentable = Photo.find(params[:photo_id])
    end
end

nus_tdt_project/app/helpers/comments_helper.rb
module CommentsHelper
end

nus_tdt_project/app/views/comments/_comments.html.slim
#comment_section
  - commentable.comments.each do |comment|
    p
      = comment.body

nus_tdt_project/app/views/comments/_form.html.slim
= form_for [commentable, Comment.new], html: { data: {remote: true}} do |form|
  .form-group.row.bg-dark.p-3
    .col-4.p-0
      .avatar-circle
        = user_avatar(User.find(commentable.user_id))
    .col-8
      = form.text_area :body, class: "form-control comment-textarea", placeholder: "Add a comment", rows: "1"
    = form.submit

nus_tdt_project/app/views/comments/edit.html.slim
h1
  | Editing Comment
= render 'form', comment: @comment
= link_to 'Show', @comment
|  | 
= link_to 'Back', comments_path

nus_tdt_project/app/views/comments/index.html.slim
p#notice
  = notice
h1
  | Comments
table
  thead
    tr
      th[colspan="3"]
  tbody
    - @comments.each do |comment|
      tr
        td
          = link_to 'Show', comment
        td
          = link_to 'Edit', edit_comment_path(comment)
        td
          = link_to 'Destroy', comment, method: :delete, data: { confirm: 'Are you sure?' }
br
= link_to 'New Comment', new_comment_path

nus_tdt_project/app/views/comments/new.html.slim
h1
  | New Comment
= render 'form', comment: @comment
= link_to 'Back', comments_path

nus_tdt_project/app/views/comments/show.html.slim
p#notice
  = notice
= link_to 'Edit', edit_comment_path(@comment)
|  | 
= link_to 'Back', comments_path